//+------------------------------------------------------------------+
//|                                       mq4tomq5_script_sample.mq4 |
//|                                                            keiji |
//|                                  http://www.dr-ea.com/meta-blog/ |
//+------------------------------------------------------------------+
#property copyright "keiji"
#property link      "http://www.dr-ea.com/meta-blog/"
#property show_inputs
#include <stdlib.mqh>
extern string MQL4FileName=".mq4";
extern string MQL5FileName=".mq5";

string text;
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
{
//----
   string filename=MQL4FileName;
   int handle;
   handle=FileOpen(filename,FILE_CSV|FILE_READ,"\t");
   if(handle<1)
   {
      Alert("File " + filename + " not found, the last error is ", ErrorDescription(GetLastError()));
      return(false);
   }
   string filename2=MQL5FileName;
   int handle2;
   handle2=FileOpen(filename2,FILE_CSV|FILE_WRITE,"\t");
   if(handle2<1)
   {
      Alert("File " + filename2 + " not found, the last error is ", ErrorDescription(GetLastError()));
      return(false);
   }
   bool init=false,start=false,deinit=false;
   
   if(handle>0 && handle2>0)
   {
      while(!FileIsEnding(handle))
      {
         text=FileReadString(handle);
         
         
         //REWRITE
         //-------------------------------FuncRewrite(string mql4 word, stirng mql5 word);
         string mq4word,mq5word;
         //extern to input
         mq4word= "extern";
         mq5word= "input";
         FuncRewrite(mq4word, mq5word);
         
         //Account Info
         mq4word= "AccountBalance(";
         mq5word= "AccountInfoDouble(ACCOUNT_BALANCE";
         FuncRewrite(mq4word, mq5word);
         
         mq4word= "AccountCredit(";
         mq5word= "AccountInfoDouble(ACCOUNT_CREDIT";
         FuncRewrite(mq4word, mq5word);
         
         mq4word= "AccountCompany(";
         mq5word= "AccountInfoString(ACCOUNT_COMPANY";
         FuncRewrite(mq4word, mq5word);
         
         mq4word= "AccountCurrency(";
         mq5word= "AccountInfoString(ACCOUNT_CURRENCY";
         FuncRewrite(mq4word, mq5word);
         
         mq4word= "AccountEquity(";
         mq5word= "AccountInfoDouble(ACCOUNT_EQUITY";
         FuncRewrite(mq4word, mq5word);
         
         mq4word= "AccountFreeMargin(";
         mq5word= "AccountInfoDouble(ACCOUNT_FREEMARGIN";
         FuncRewrite(mq4word, mq5word);
         
         //AccountFreeMarginCheck(string symbol, int cmd, double volume)
         //AccountFreeMarginMode()
         
         mq4word= "AccountLeverage(";
         mq5word= "AccountInfoInteger(ACCOUNT_LEVERAGE";
         FuncRewrite(mq4word, mq5word);
         
         mq4word= "AccountMargin(";
         mq5word= "AccountInfoDouble(ACCOUNT_MARGIN";
         FuncRewrite(mq4word, mq5word);
         
         mq4word= "AccountName(";
         mq5word= "AccountInfoString(ACCOUNT_NAME";
         FuncRewrite(mq4word, mq5word);
         
         mq4word= "AccountNumber(";
         mq5word= "AccountInfoInteger(ACCOUNT_LOGIN";
         FuncRewrite(mq4word, mq5word);
         
         mq4word= "AccountProfit(";
         mq5word= "AccountInfoDouble(ACCOUNT_PROFIT";
         FuncRewrite(mq4word, mq5word);
         
         mq4word= "AccountServer(";
         mq5word= "AccountInfoString(ACCOUNT_SERVER";
         FuncRewrite(mq4word, mq5word);
         
         mq4word= "AccountStopoutLevel(";
         mq5word= "AccountInfoDouble(ACCOUNT_MARGIN_SO_SO";
         FuncRewrite(mq4word, mq5word);
         
         mq4word= "AccountStopoutMode(";
         mq5word= "AccountInfoInteger(ACCOUNT_MARGIN_SO_MODE";
         FuncRewrite(mq4word, mq5word);


         //String Function
         mq4word= "CharToStr(";
         mq5word= "CharToString(";
         FuncRewrite(mq4word, mq5word);
         
         mq4word= "DoubleToStr(";
         mq5word= "DoubleToString(";
         FuncRewrite(mq4word, mq5word);
         
         mq4word= "StrToDouble(";
         mq5word= "StringToDouble(";
         FuncRewrite(mq4word, mq5word);
         
         mq4word= "StrToInteger(";
         mq5word= "StringToInteger(";
         FuncRewrite(mq4word, mq5word);
         
         mq4word= "StrToTime(";
         mq5word= "StringToTime(";
         FuncRewrite(mq4word, mq5word);
         
         mq4word= "TimeToStr(";
         mq5word= "TimeToString(";
         FuncRewrite(mq4word, mq5word);

         
         int i=0;
         //ADD
         if(!init && !start && !deinit)
         {
            for(i=0;i<StringLen(text)-4;i++)
            {
               if(StringSubstr(text,i,5)=="init(")
               {
                  init=true;
                  break;
               }
               if(StringSubstr(text,i,6)=="start(")
               {
                  start=true;
                  break;
               }
               if(StringSubstr(text,i,7)=="deinit(")
               {
                  deinit=true;
                  break;
               }
            }
         }
         if(init || start || deinit)
         {
            while(i<StringLen(text))
            {
               if(StringSubstr(text,i,1)=="{")
               {
                  text=StringSubstr(text,0,i+1)+
                     "\n//:::::::::::::::::::::::::::::::::::::::::::::\n"+
                     "double Ask=SymbolInfoDouble(Symbol(),SYMBOL_ASK);\n"+
                     "double Bid=SymbolInfoDouble(Symbol(),SYMBOL_BID);\n"+
                     "int Bars=Bars(Symbol(),PERIOD_CURRENT);\n"+
                     "double Point=Point();\n"+
                     "//Etc.\n"+
                     "//:::::::::::::::::::::::::::::::::::::::::::::::\n"+
                     StringSubstr(text,i+1);
                  init=false;
                  start=false;
                  deinit=false;
                  break;
               }
               i++;
            }
         }
         FileWrite(handle2,text);
      }
      FileClose(handle);
      FileClose(handle2);
   }
   Alert("Complete rewriting!");
//----
   return(0);
}

string FuncRewrite(string mq4word, string mq5word)
{
   int length=StringLen(mq4word);
   for(int i=0;i<StringLen(text)-length+1;i++)
   {
      if(StringSubstr(text,i,length)==mq4word)
      {
         if(i==0) text=mq5word+StringSubstr(text,length);
         else text=StringSubstr(text,0,i)+mq5word+StringSubstr(text,i+length);
      }
   }
}